#include <stdlib.h>
#include <jni.h>
#include <android/log.h>

extern "C"
{

JavaVM*		java_vm;
jobject		AndroidHelper;
  //jmethodID	swarmInit;
jmethodID       facebookPostOnWall;
jmethodID       requestFriendNames;
/*jmethodID	iapAppStoreInit;
jmethodID	iapGetIsProductPurchased;
jmethodID	iapPurchaseProduct;
jmethodID	iapRestorePurchases;*/

  //void PluginInit();

jint JNI_OnLoad(JavaVM* vm, void* reserved)
{
	// use __android_log_print for logcat debugging...
        __android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] Creating java link vm = %08x\n", __FUNCTION__, (unsigned int)vm);
	java_vm = vm;

	if(vm == 0)
	  {
	    return JNI_VERSION_1_6;
	  }

	// attach our thread to the java vm; obviously it's already attached but this way we get the JNIEnv..
	JNIEnv* jni_env = 0;
	java_vm->AttachCurrentThread(&jni_env, 0);

	if(jni_env == 0)
	  {
	    return JNI_VERSION_1_6;
	  }

	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] JNI Environment is = %08x\n", __FUNCTION__, (unsigned int)jni_env);

	// first we try to find our main activity..
	jclass cls_Activity		= jni_env->FindClass("com/unity3d/player/UnityPlayer");
	jfieldID fid_Activity	= jni_env->GetStaticFieldID(cls_Activity, "currentActivity", "Landroid/app/Activity;");
	jobject obj_Activity	= jni_env->GetStaticObjectField(cls_Activity, fid_Activity);
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] Current activity = %08x\n", __FUNCTION__, (unsigned int)obj_Activity);

	// create a SwarmHelper object...
	jclass cls_AndroidHelper	= jni_env->FindClass("com/mikamikem/AndroidUnity/AndroidHelper");
	jmethodID mid_AndroidHelper	= jni_env->GetMethodID(cls_AndroidHelper, "<init>", "()V");
	jobject obj_AndroidHelper	= jni_env->NewObject(cls_AndroidHelper, mid_AndroidHelper);
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] AndroidHelper object = %08x\n", __FUNCTION__, (unsigned int)obj_AndroidHelper);

	// create a global reference to the AndroidHelper object and fetch method id(s)..
	AndroidHelper				= jni_env->NewGlobalRef(obj_AndroidHelper);
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] AndroidHelper global ref = %08x\n", __FUNCTION__, (unsigned int)AndroidHelper);
	facebookPostOnWall		= jni_env->GetMethodID(cls_AndroidHelper, "PostOnWall", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V");
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] AndroidHelper method id = %08x\n", __FUNCTION__, (unsigned int)facebookPostOnWall);
	requestFriendNames              = jni_env->GetMethodID(cls_AndroidHelper, "RequestFriendNames", "(Ljava/lang/String;)V");
        __android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] AndroidHelper method id = %08x\n", __FUNCTION__, (unsigned int)requestFriendNames);
/*	iapAppStoreInit			= jni_env->GetMethodID(cls_AndroidHelper, "AppStoreInit", "()V");
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] AndroidHelper method id = %08x\n", __FUNCTION__, (unsigned int)iapAppStoreInit);
	iapGetIsProductPurchased= jni_env->GetMethodID(cls_AndroidHelper, "GetIsProductPurchased", "(Ljava/lang/String;)V");
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] AndroidHelper method id = %08x\n", __FUNCTION__, (unsigned int)iapGetIsProductPurchased);
	iapPurchaseProduct		= jni_env->GetMethodID(cls_AndroidHelper, "PurchaseProduct", "(Ljava/lang/String;)V");
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] AndroidHelper method id = %08x\n", __FUNCTION__, (unsigned int)iapPurchaseProduct);
	iapRestorePurchases		= jni_env->GetMethodID(cls_AndroidHelper, "RestorePurchases", "()V");
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] AndroidHelper method id = %08x\n", __FUNCTION__, (unsigned int)iapRestorePurchases);*/
	
	return JNI_VERSION_1_6;		// minimum JNI version
}

/*char* cacheDir = 0;
const char* getCacheDir()
{
	if (cacheDir)
		return cacheDir;
		
	JNIEnv* jni_env = 0;
	java_vm->AttachCurrentThread(&jni_env, 0);

	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] called, attached to %08x\n", __FUNCTION__, jni_env);

	jstring str_cacheDir 	= (jstring)jni_env->CallObjectMethod(JavaClass, getActivityCacheDir);
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] str_cacheDir = %08x\n", __FUNCTION__, jni_env);
	
	jsize stringLen = jni_env->GetStringUTFLength(str_cacheDir);
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] stringLen = %i\n", __FUNCTION__, stringLen);
	
	cacheDir = new char[stringLen+1];
	
	const char* path = jni_env->GetStringUTFChars(str_cacheDir, 0);
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] path = %s\n", __FUNCTION__, path);
	
	strcpy(cacheDir, path);

	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] return value is = %i\n", __FUNCTION__, cacheDir);
	
	return cacheDir;
}*/

/*void SwarmLogin()
{
	JNIEnv* jni_env = 0;
	java_vm->AttachCurrentThread(&jni_env, 0);

	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] called, attached to %08x\n", __FUNCTION__, jni_env);

	jni_env->CallVoidMethod(SwarmHelper, swarmLogin);
}

void SwarmDashboard()
{
	JNIEnv* jni_env = 0;
	java_vm->AttachCurrentThread(&jni_env, 0);

	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] called, attached to %08x\n", __FUNCTION__, jni_env);

	jni_env->CallVoidMethod(SwarmHelper, swarmDashboard);
}

void SwarmShowLeaderboardUI(int LeaderboardID)
{
	JNIEnv* jni_env = 0;
	java_vm->AttachCurrentThread(&jni_env, 0);

	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] called, attached to %08x\n", __FUNCTION__, jni_env);

	jni_env->CallVoidMethod(SwarmHelper, swarmLeaderboardUI, LeaderboardID);
}

void SwarmUnlockAchievement(int AchievementID)
{
	JNIEnv* jni_env = 0;
	java_vm->AttachCurrentThread(&jni_env, 0);

	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] called, attached to %08x\n", __FUNCTION__, jni_env);

	jni_env->CallVoidMethod(SwarmHelper, swarmUnlockAchievement, AchievementID);
}

void SwarmUpdateAchievements()
{
	JNIEnv* jni_env = 0;
	java_vm->AttachCurrentThread(&jni_env, 0);

	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] called, attached to %08x\n", __FUNCTION__, jni_env);

	jni_env->CallVoidMethod(SwarmHelper, swarmUpdateAchievements);
}

void SwarmIsUnlocked(int AchievementID)
{
	JNIEnv* jni_env = 0;
	java_vm->AttachCurrentThread(&jni_env, 0);

	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] called, attached to %08x\n", __FUNCTION__, jni_env);

	jni_env->CallVoidMethod(SwarmHelper, swarmIsUnlocked, AchievementID);
}

void SwarmSubmitScore(int LeaderboardID, float NewScore)
{
	JNIEnv* jni_env = 0;
	java_vm->AttachCurrentThread(&jni_env, 0);

	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] called, attached to %08x\n", __FUNCTION__, jni_env);

	jni_env->CallVoidMethod(SwarmHelper, swarmSubmitScore, LeaderboardID, NewScore);
}

void SwarmGetScoreList(int LeaderboardID)
{
	JNIEnv* jni_env = 0;
	java_vm->AttachCurrentThread(&jni_env, 0);

	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] called, attached to %08x\n", __FUNCTION__, jni_env);

	jni_env->CallVoidMethod(SwarmHelper, swarmGetScoreList, LeaderboardID);
}

void SwarmUpdateScores()
{
	JNIEnv* jni_env = 0;
	java_vm->AttachCurrentThread(&jni_env, 0);

	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] called, attached to %08x\n", __FUNCTION__, jni_env);

	jni_env->CallVoidMethod(SwarmHelper, swarmUpdateScores);
	}*/

void PostOnWall(char* Caption, char* Description, char* GameName, char* IconURL)
{
	JNIEnv* jni_env = 0;
	java_vm->AttachCurrentThread(&jni_env, 0);
	jstring JCaption = jni_env->NewStringUTF(Caption);
	jstring JDescription = jni_env->NewStringUTF(Description);
	jstring JGameName = jni_env->NewStringUTF(GameName);
	jstring JIconURL = jni_env->NewStringUTF(IconURL);

	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] called, attached to %08x\n", __FUNCTION__, (unsigned int)jni_env);

	jni_env->CallVoidMethod(AndroidHelper, facebookPostOnWall, JCaption, JDescription, JGameName, JIconURL);
}

void RequestFriendNames(char* PrefabName)
{
        JNIEnv* jni_env = 0;
	java_vm->AttachCurrentThread(&jni_env, 0);
	jstring JPrefabName = jni_env->NewStringUTF(PrefabName);

	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] called, attached to %08x\n", __FUNCTION__, (unsigned int)jni_env);

	jni_env->CallVoidMethod(AndroidHelper, requestFriendNames, JPrefabName);
}

/*void AppStoreInit()
{
	JNIEnv* jni_env = 0;
	java_vm->AttachCurrentThread(&jni_env, 0);

	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] called, attached to %08x\n", __FUNCTION__, (unsigned int)jni_env);

	jni_env->CallVoidMethod(AndroidHelper, iapAppStoreInit);
}

void GetIsProductPurchased(char* ProductID)
{
	JNIEnv* jni_env = 0;
	java_vm->AttachCurrentThread(&jni_env, 0);
	jstring JProductID = jni_env->NewStringUTF(ProductID);

	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] called, attached to %08x\n", __FUNCTION__, (unsigned int)jni_env);

	jni_env->CallVoidMethod(AndroidHelper, iapGetIsProductPurchased, JProductID);
}

void PurchaseProduct(char* ProductID)
{
	JNIEnv* jni_env = 0;
	java_vm->AttachCurrentThread(&jni_env, 0);
	jstring JProductID = jni_env->NewStringUTF(ProductID);

	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] called with %s, attached to %08x\n", __FUNCTION__, ProductID, (unsigned int)jni_env);

	jni_env->CallVoidMethod(AndroidHelper, iapPurchaseProduct, JProductID);
}

void RestorePurchases()
{
	JNIEnv* jni_env = 0;
	java_vm->AttachCurrentThread(&jni_env, 0);

	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "[%s] called, attached to %08x\n", __FUNCTION__, (unsigned int)jni_env);

	jni_env->CallVoidMethod(AndroidHelper, iapRestorePurchases);
}*/

// http://www.reigndesign.com/blog/unity-native-plugins-os-x/
// http://forum.unity3d.com/threads/84380-possible-to-call-C-Javascript-back-from-plugin-bundle-on-mac
// http://www.mono-project.com/Embedding_Mono


/*
typedef void* MonoDomain;

typedef void* MonoAssembly;

typedef void* MonoImage;

typedef void* MonoClass;

typedef void* MonoObject;

typedef void* MonoMethodDesc;

typedef void* MonoMethod;

typedef void* MonoString;

typedef int gboolean;

typedef void* gpointer;

typedef void* MonoThread;



MonoDomain *mono_jit_init(const char *file);

MonoDomain *mono_domain_get();

MonoAssembly *mono_domain_assembly_open(MonoDomain *domain, const char *assemblyName);

MonoImage *mono_assembly_get_image(MonoAssembly *assembly);

MonoMethodDesc *mono_method_desc_new(const char *methodString, gboolean useNamespace);

MonoMethodDesc *mono_method_desc_free(MonoMethodDesc *desc);

MonoMethod *mono_method_desc_search_in_image(MonoMethodDesc *methodDesc, MonoImage *image);

MonoObject *mono_runtime_invoke(MonoMethod *method, void *obj, void **params, MonoObject **exc);

MonoClass *mono_class_from_name(MonoImage *image, const char *namespaceString, const char *classnameString);

MonoMethod *mono_class_get_methods(MonoClass*, gpointer* iter);

MonoString *mono_string_new(MonoDomain *domain, const char *text);

char* mono_method_get_name (MonoMethod *method);

MonoThread *mono_thread_attach(MonoDomain *domain);


MonoDomain *domain;
const char *assemblyPath;
MonoAssembly *monoAssembly;
MonoImage *monoImage;

MonoMethodDesc *gotAchievementsCBDesc;
MonoMethod *gotAchievementsCB;

MonoMethodDesc *updateAchievementStateDesc;
MonoMethod *updateAchievementState;

MonoMethodDesc *updateScoreDesc;
MonoMethod *updateScore;

MonoMethodDesc *updateLoggedInDesc;
MonoMethod *updateLoggedIn;

void PluginInit()
{
    assemblyPath = "assets/bin/Data/Managed/Assembly-CSharp-firstpass.dll";

    domain = mono_domain_get();
    monoAssembly = mono_domain_assembly_open(domain, assemblyPath);
    monoImage = mono_assembly_get_image(monoAssembly);

    gotAchievementsCBDesc = mono_method_desc_new("SwarmIntegration:GotAchievements()", false);
    gotAchievementsCB = mono_method_desc_search_in_image(gotAchievementsCBDesc, monoImage);
    mono_method_desc_free(gotAchievementsCBDesc);

    updateAchievementStateDesc = mono_method_desc_new("SwarmIntegration:UpdateAchievementState(int,bool)", false);
    updateAchievementState = mono_method_desc_search_in_image(updateAchievementStateDesc, monoImage);
    mono_method_desc_free(updateAchievementStateDesc);

    updateScoreDesc = mono_method_desc_new("SwarmIntegration:UpdateScore", false);
    updateScore = mono_method_desc_search_in_image(updateScoreDesc, monoImage);
    mono_method_desc_free(updateScoreDesc);

    updateLoggedInDesc = mono_method_desc_new("SwarmIntegration:UpdateLoggedIn", false);
    updateLoggedIn = mono_method_desc_search_in_image(updateLoggedInDesc, monoImage);
    mono_method_desc_free(updateLoggedInDesc);
}

JNIEXPORT void JNICALL Java_com_mikamikem_SwarmUnity_SwarmHelper_GotAchievementsCB(JNIEnv *env, jobject obj)
{
	mono_thread_attach(domain);
//	PluginInit();
	// Maybe do an arrya of ids passed back so that they can query each ID?
	// Bad interface, but this whole process is kind of for shit...
	float param1 = 100.5f; //some float

    float param2 = 200.7f; //another float

    void *args[] = { &param1, &param2 };

    mono_runtime_invoke(gotAchievementsCB, NULL, NULL, NULL);
}

JNIEXPORT void JNICALL Java_com_mikamikem_SwarmUnity_SwarmHelper_UpdateAchievementState(JNIEnv *env, jobject obj, jint JAchievementID, jboolean JbUnlocked)
{
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "UpdateAchievementState with fp = %08x\n", updateAchievementState);
	mono_thread_attach(domain);

	int AchievementID = JAchievementID;
	bool bUnlocked = JbUnlocked == JNI_TRUE;
	
	void *args[] = { &AchievementID, &bUnlocked };
	
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "Before call\n");
	mono_runtime_invoke(updateAchievementState, NULL, args, NULL);
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "After call\n");
}

JNIEXPORT void JNICALL Java_com_mikamikem_SwarmUnity_SwarmHelper_UpdateScore(JNIEnv *env, jobject obj, jint JScoreRank, jfloat JScore)
{
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "UpdateScore with fp = %08x\n", updateScore);
	mono_thread_attach(domain);

	int ScoreRank = JScoreRank;
	float Score = JScore;
	
	void *args[] = { &ScoreRank, &Score };
	
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "Before call\n");
	mono_runtime_invoke(updateScore, NULL, args, NULL);
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "After call\n");
}

JNIEXPORT void JNICALL Java_com_mikamikem_SwarmUnity_SwarmHelper_UpdateLoggedIn(JNIEnv *env, jobject obj, jboolean JbLoggedIn)
{
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "UpdateLoggedIn with fp = %08x\n", updateLoggedIn);
	mono_thread_attach(domain);

	bool bLoggedIn = JbLoggedIn == JNI_TRUE;
	
	void *args[] = { &bLoggedIn };
	
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "Before call\n");
	mono_runtime_invoke(updateLoggedIn, NULL, args, NULL);
	__android_log_print(ANDROID_LOG_INFO, "JavaBridge", "After call\n");
}*/

} // extern "C"
