#!/bin/sh

export ANDROID_NDK_ROOT="/Users/michael/android-ndk"
export ANDROID_SDK_ROOT="/Users/michael/android-sdk"
export UNITY_JAVA_CLASSPATH="/Applications/Unity/Unity.app/Contents/PlaybackEngines/AndroidPlayer/bin/classes.jar"
export BASE_JAVA_CLASSPATH="$ANDROID_SDK_ROOT/platforms/android-9/android.jar"
export LOCAL_JAVA_CLASSPATH="../lib/android-support-v4.jar:./"
#export LOCAL_JAVA_CLASSPATH=":./"
export FULL_JAVA_CLASSPATH="$BASE_JAVA_CLASSPATH:$UNITY_JAVA_CLASSPATH:$LOCAL_JAVA_CLASSPATH"

export JAVAC_PARAMS="-bootclasspath /System/Library/Java/JavaVirtualMachines/1.6.0.jdk/Contents/Home/bundle/Classes/classes.jar -classpath $FULL_JAVA_CLASSPATH -d ."

echo ""
echo "Generating IMarketBillingService..."
$ANDROID_SDK_ROOT/build-tools/18.0.1/aidl -p$ANDROID_SDK_ROOT/platforms/android-8/framework.aidl com/android/vending/billing/IMarketBillingService.aidl

echo ""
echo "Building AndroidUnityActivity..."
javac com/mikamikem/AndroidUnity/AndroidUnityActivity.java $JAVAC_PARAMS
echo "Building AndroidHelper..."
javac com/mikamikem/AndroidUnity/AndroidHelper.java $JAVAC_PARAMS
echo "Building IMarketBillingService..."
javac com/android/vending/billing/IMarketBillingService.java $JAVAC_PARAMS
echo "Building BillingReceiver..."
javac com/google/billing/BillingReceiver.java $JAVAC_PARAMS
echo "Building BillingService..."
javac com/google/billing/BillingService.java $JAVAC_PARAMS
echo "Building Consts..."
javac com/google/billing/Consts.java $JAVAC_PARAMS
echo "Building PurchaseDatabase..."
javac com/google/billing/PurchaseDatabase.java $JAVAC_PARAMS
echo "Building PurchaseObserver..."
javac com/google/billing/PurchaseObserver.java $JAVAC_PARAMS
echo "Building ResponseHandler..."
javac com/google/billing/ResponseHandler.java $JAVAC_PARAMS
echo "Building Security..."
javac com/google/billing/Security.java $JAVAC_PARAMS
echo "Building Base64..."
javac com/google/billing/util/Base64.java $JAVAC_PARAMS
echo "Building Base64DecoderException..."
javac com/google/billing/util/Base64DecoderException.java $JAVAC_PARAMS

echo ""
echo "Signature dump of AndroidUnityActivity..."

javap -s com.mikamikem.AndroidUnity.AndroidUnityActivity

echo "Creating AndroidUnity.jar..."
jar cvfM ../AndroidUnity.jar com/

echo ""
echo "Compiling NativeAndroidBridge.cpp..."
$ANDROID_NDK_ROOT/ndk-build V=1 NDK_PROJECT_PATH=. NDK_APPLICATION_MK=Application.mk $* NDK_LOG=1 NDK_DEBUG=1
mv libs/armeabi/libjavabridge.so ..

echo ""
echo "Cleaning up / removing build folders..."  #optional..
rm -rf libs
rm -rf obj
rm -rf org

echo ""
echo "Done!"
